#include"ebmlut.hpp"




namespace ebmlut{




ElementID::
ElementID(const char*  _fullname, std::initializer_list<uint8_t>  _codes, DataType  _type):
fullname(_fullname),
codes(_codes),
data_type(_type)
{
  VInt  vint;

  vint.read(codes);

  value = vint.get_value();
}




const char*
ElementID::
get_data_type_string(DataType  _type)
{
  const char*  s = "unknown";

    switch(_type)
    {
      case(DAT_unsigned_integer): s = "uint";break;
      case(DAT_signed_integer  ): s = "int";break;
      case(DAT_date            ): s = "date";break;
      case(DAT_float           ): s = "float";break;
      case(DAT_string          ): s = "string";break;
      case(DAT_utf8            ): s = "utf8";break;
      case(DAT_binary          ): s = "binary";break;
      case(DAT_master          ): s = "master";break;
    }


  return s;
}


void
ElementID::
print(bool  detail) const
{
  printf("%32s(%8s)",fullname.data(),get_data_type_string(data_type));

    if(detail)
    {
      printf("{0x");

        for(auto  c: codes)
        {
          printf("%02X",c);
        }


      printf("}");
    }


  printf(":");
}




}




