#ifndef EBMLUT_ELEMENT_ID_HPP_INCLUDED
#define EBMLUT_ELEMENT_ID_HPP_INCLUDED


#include"ebmlut_misc.hpp"




namespace ebmlut{




enum DataType{
  DAT_null,
  DAT_signed_integer,
  DAT_unsigned_integer,
  DAT_float,
  DAT_string,
  DAT_utf8,
  DAT_date,
  DAT_binary,
  DAT_master,
};


struct
ElementID
{
  std::string  fullname;

  using Codes = std::vector<uint8_t>;

  Codes  codes;

  uint64_t  value;

  DataType  data_type;

  ElementID(const char*  _fullname, std::initializer_list<uint8_t>  _codes, DataType  _type);


  static const char*  get_data_type_string(DataType  _type);

  void  print(bool  detail=false) const;


  static const ElementID  null;

};


class
ElementIDTree
{
  std::vector<ElementID>  nodes;

public:
  ElementIDTree(std::initializer_list<ElementID>  ls);

  const ElementID*  operator[](const std::string&  fullname) const;
  const ElementID*  operator[](uint64_t  v) const;

  void  print() const;

};


extern const ElementIDTree  id_tree;


}


#endif




