#include"ebmlut_misc.hpp"




namespace{
constexpr size_t
get_vint_size(uint8_t  i)
{
  return(((i>>7) == 1)? 1:
         ((i>>6) == 1)? 2:
         ((i>>5) == 1)? 3:
         ((i>>4) == 1)? 4:
         ((i>>3) == 1)? 5:
         ((i>>2) == 1)? 6:
         ((i>>1) == 1)? 7:    
         ((i   ) == 1)? 8:0);
}


constexpr uint64_t
shifted(uint64_t  i, int  amount)
{
  return((i>>amount)&0xFF);
}


}


namespace ebmlut{




size_t
VInt::
read(std::vector<uint8_t>&  ls)
{
  size = ls.size();

  auto  p = raw_codes;

    for(auto  v: ls)
    {
      *p++ = v;
    }


  return size;
}


size_t
VInt::
read(std::initializer_list<uint8_t>  ls)
{
  size = ls.size();

  auto  p = raw_codes;

    for(auto  v: ls)
    {
      *p++ = v;
    }


  return size;
}


size_t
VInt::
read(FILE*  f)
{
  auto  p = raw_codes;

  int  c = fgetc(f);

  *p++ = c;

  size = get_vint_size(c);


  int  n = size;

    while(--n)
    {
      *p++ = fgetc(f);
    }


  return size;
}


void
VInt::
print() const
{
  printf("[vint] <%d> 0x",size);

    rep(i,size)
    {
      printf("%02X",raw_codes[i]);
    }


  printf("\n");
}


uint64_t
VInt::
get_value(bool  strip) const
{
  auto  p = raw_codes;

  uint64_t  i = *p++;

    if(strip)
    {
      i &= (0xFF>>size);
    }


  int  n = size;

    while(--n)
    {
      i <<=    8;
      i  |= *p++;
    }


  return i;
}


uint64_t
VInt::
get_decoded_value() const
{
  return get_value(true);
}


void
fput_vint(uint64_t  i, FILE*  f)
{
  fputc(         0x01,f);
  fputc(shifted(i,48),f);
  fputc(shifted(i,40),f);
  fputc(shifted(i,32),f);
  fputc(shifted(i,24),f);
  fputc(shifted(i,16),f);
  fputc(shifted(i, 8),f);
  fputc(shifted(i, 0),f);
}




}




