#include"ebmlut.hpp"




namespace ebmlut{




Primitives::
Primitives(const ElementID*  _id, FILE*  f, size_t  f_data_size):
Element(_id)
{
  u64_ = 0;

    while(f_data_size--)
    {
      u64_ <<= 8;
      u64_  |= fgetc(f);
    }
}


size_t
Primitives::
get_data_size() const
{
  return 8;
}




 int64_t  Primitives::get_i64() const{return i64_;}
uint64_t  Primitives::get_u64() const{return u64_;}
double    Primitives::get_f64() const{return f64_;}

void  Primitives::set_i64( int64_t  i64){i64_ = i64;}
void  Primitives::set_u64(uint64_t  u64){u64_ = u64;}
void  Primitives::set_f64(double    f64){f64_ = f64;}


void
Primitives::
print() const
{
  Element::print();

    switch(id->data_type)
    {
      case(DAT_signed_integer):
        printf("%lld",i64_);
        break;
      case(DAT_unsigned_integer):
      case(DAT_date):
        printf("%llu",u64_);
        break;
      case(DAT_float):
        printf("%f",f64_);
        break;
    }
}


}





